# -*- coding: utf-8 -*-
"""
/***************************************************************************
 PlantingPattern
                                 A QGIS plugin
 This pluggin make a point layer of planting pattern in the most commonly patterns square spaccing and triangular spacing
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2019-12-10
        git sha              : $Format:%H$
        copyright            : (C) 2019 by Cenipalma
        email                : vrincon@cenipalma.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from PyQt5.QtCore import QSettings, QTranslator, qVersion, QCoreApplication
from PyQt5.QtGui import QIcon
from PyQt5.QtWidgets import QAction, QFileDialog,QMessageBox

import sys

from qgis.core import *
from qgis.gui import *
from qgis.utils import  *
from qgis.analysis import *
from math import *
import ctypes  # An included library with Python install.


# Initialize Qt resources from file resources.py
from .resources import *

# Import the code for the dialog
from .PlantingPattern_dialog import PlantingPatternDialog
from qgis.core import QgsVectorFileWriter
import os.path


class PlantingPattern:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'PlantingPattern_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)
            QCoreApplication.installTranslator(self.translator)
		
		# Create the dialog (after translation) and keep reference
        self.dlg = PlantingPatternDialog()
		
        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&Planting Pattern')
        # TODO: We are going to let the user set this up in a future iteration
        self.toolbar = self.iface.addToolBar(u'PlantingPattern')
        self.toolbar.setObjectName(u'PlantingPattern')

        
        
		
		


    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('PlantingPattern', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            # Adds plugin icon to Plugins toolbar
            self.iface.addToolBarIcon(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/PlantingPattern/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u'Make planting pattern'),
            callback=self.run,
            parent=self.iface.mainWindow())
        

        # will be set False in run()
        self.first_start = True
        
        


    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&PlantingPattern'),
                action)
            self.iface.removeToolBarIcon(action)

    # Metodo para seleccionar elarchivo a guardar
    def select_output_file(self):
        filename = QFileDialog.getSaveFileName(self.dlg, "Select output file ","", '*.shp')
        self.dlg.leSave.setText(str(filename[0]))
    
    
    def onLayerChange(self, index):

        self.dlg.cb_plot.clear() # clears the combobox
        self.dlg.cb_fix_2.clear() # clears the combobox
        self.dlg.cb_x.clear() # clears the combobox
        self.dlg.cb_y.clear() # clears the combobox
        self.dlg.cb_plantdist.clear() # clears the combobox
        self.dlg.cb_linedist.clear() # clears the combobox
        self.dlg.cb_azimuth.clear() # clears the combobox
        self.dlg.cb_direction_2.clear() # clears the combobox
        
        self.dlg.cb_plot.addItem( "" ) # add lists layer fields
        self.dlg.cb_fix_2.addItem( "" ) # add lists layer fields
        self.dlg.cb_x.addItem( "" ) # add lists layer fields
        self.dlg.cb_y.addItem( "" ) # add lists layer fields
        self.dlg.cb_plantdist.addItem( "" ) # add lists layer fields
        self.dlg.cb_linedist.addItem( "" ) # add lists layer fields
        self.dlg.cb_azimuth.addItem( "" ) # add lists layer fields
        self.dlg.cb_direction_2.addItem( "" ) # add lists layer fields
        
        layer = self.dlg.cbLayer_2.itemData( index ) # gets selected layer
        
        for field in layer.fields():
            self.dlg.cb_plot.addItem( field.name(), field ) # add lists layer fields
            self.dlg.cb_fix_2.addItem( field.name(), field ) # add lists layer fields
            self.dlg.cb_x.addItem( field.name(), field ) # add lists layer fields
            self.dlg.cb_y.addItem( field.name(), field ) # add lists layer fields
            self.dlg.cb_plantdist.addItem( field.name(), field ) # add lists layer fields
            self.dlg.cb_linedist.addItem( field.name(), field ) # add lists layer fields
            self.dlg.cb_azimuth.addItem( field.name(), field ) # add lists layer fields
            self.dlg.cb_direction_2.addItem( field.name(), field ) # add lists layer fields
    
    #Prueba de funcion
    def funcion(self):
    
        def Mbox(title, text, style):
            ctypes.windll.user32.MessageBoxA(0, text, title, style)
            ##  Styles:
            ##  0 : OK
            ##  1 : OK | Cancel
            ##  2 : Abort | Retry | Ignore
            ##  3 : Yes | No | Cancel
            ##  4 : Yes | No
            ##  5 : Retry | No 
            ##  6 : Cancel | Try Again | Continue

        # Parametros de entrada
        if self.dlg.cbLayer.currentIndex() <0:
            QMessageBox.information(self.iface.mainWindow(),'Atención', 'Seleccione una capa para continuar')
            return None
        
        
            
        # Layer selected
        registry = QgsProject.instance()
        layer=registry.mapLayersByName( self.dlg.cbLayer.currentText() )[0]
        
        #Pendiente revisar si hay elementos seleccionados
        
        if layer.selectedFeatureCount() ==0:
            QMessageBox.information(self.iface.mainWindow(),'Atención', 'La capa no tiene un polígono seleccionado')
            return None
            
        feat = layer.selectedFeatures()[0]
        geom = feat.geometry()
        
        #QMessageBox.information(self.iface.mainWindow(),'Atención', "Area: " + str(geom.area()))
        
        layer_crs =layer.crs()
        
        #Creacion del punto de la primera palma
        punto=QgsPointXY(self.dlg.dblX.value(),self.dlg.dblY.value())
       
        
        palma=1
        linea=1
        azimut=self.dlg.dblAzimuth.value()
        direccion=self.dlg.cbDirection.currentIndex()  # 1 si es derecha, 2 si es izquierda
        distancia=self.dlg.dblDistance.value()
        distancia2=self.dlg.dblDistance_2.value()
        isosceles=self.dlg.opIsosceles
        hipotenusa=sqrt(((distancia/2)*(distancia/2))+(distancia2*distancia2))
        lote=self.dlg.strLote.text()
        print("hipo: " +str(hipotenusa))
        
        if not geom.contains(punto):
            QMessageBox.information(self.iface.mainWindow(),'Atención', 'La palma 1 no se encuentra contenida en el lote')
            return None

        
        if not layer.isValid():
            QMessageBox.information(self.iface.mainWindow(),'Atención', 'La capa seleccionada no es tipo vector')
            return None

        # Se valida si la capa es poligono wkbType==3
        #if layer.wkbType()!=QgsWkbTypes.PolygonGeometry:
        #    QMessageBox.information(self.iface.mainWindow(),'Atención', 'La capa seleccionada no es de tipo polígono, seleccione una capa tipo polígono')
        #    return None
        #else:
        #    if layer_crs.mapUnits()!=0:
        #        QMessageBox.information(self.iface.mainWindow(),'Atención', 'La capa debe tener coordenadas planas')
        #        return None
        if distancia<=0:
            QMessageBox.information(self.iface.mainWindow(),'Atención', 'La distancia entre las líneas debe ser mayor a 0')
            return None

        # Creacion de la capa para poligono envolvente
        convexhull=geom.convexHull()
        polBuffer=geom.buffer(distancia*20,1) # Se aumenta a 10 la distancia para garantizar que se cubra la parte externa del poligono en el caso de poligonos irregulares

        # Cuadrado envolvente
        rec_lote = geom.boundingBox()

        # Extraccion del CRS de la capa
        CRS = layer.crs().postgisSrid()

        # Creacion d capa temporal para Poligono Envolvente
        URI = "Polygon?crs=epsg:"+str(CRS)+"&field=id:integer""&index=yes"
        tmp_AreaGeneral=QgsVectorLayer(URI,"convexhull","memory")
        #QgsMapLayerRegistry.instance().addMapLayer(tmp_AreaGeneral)


        # Edicion de la capa temporal para carga del poligono envolvente
        tmp_AreaGeneral.startEditing()
        feat2 = QgsFeature()
        feat2.setGeometry(convexhull)
        feat2.setAttributes([1])
        tmp_AreaGeneral.addFeature(feat2)
        tmp_AreaGeneral.commitChanges()
        iface.mapCanvas().refresh()


        # Creacion de capa para palmas
        if isosceles.isChecked():
            tmp_Palmas=QgsVectorLayer("Point?crs=epsg:3116&field=id:integer""&field=x:double""&field=y:double""&field=codigo:string""&field=lote:string""&field=linea:integer""&field=planta:integer&index=yes","plantas_lote_iso","memory")
        else:
            tmp_Palmas=QgsVectorLayer("Point?crs=epsg:3116&field=id:integer""&field=x:double""&field=y:double""&field=codigo:string""&field=lote:string""&field=linea:integer""&field=planta:integer&index=yes","plantas_lote_equi","memory")
                
        if self.dlg.leSave.text() =="Temporal" or self.dlg.leSave.text() =="" :
            QgsProject.instance().addMapLayer(tmp_Palmas)
        else:
            QgsVectorFileWriter.writeAsVectorFormat(tmp_Palmas, self.dlg.leSave.text(), "UTF-8", tmp_Palmas.crs(), "ESRI Shapefile")
            tmp_Palmas=QgsVectorLayer(self.dlg.leSave.text(),"Palmas")
            QgsProject.instance().addMapLayer(tmp_Palmas)
          

        # Insertar palmas

        tmp_Palmas.startEditing()
        featPalma=QgsFeature()

        PuntoNuevo=punto
        px=PuntoNuevo.x()
        py=PuntoNuevo.y()


        if azimut<=90:
            azimut=90-azimut
        else:
            azimut=450-azimut
        
 
        
        if direccion==1:# Direccion de las lineas hacia la derecha
            if isosceles.isChecked():
                angulo_linea=(pi*azimut)/180 - atan((distancia2)/(distancia/2))
            else:
                angulo_linea=(pi*(azimut-60))/180
        else:
            if isosceles.isChecked():
                angulo_linea=(pi*azimut)/180 + atan((distancia2)/(distancia/2))
            else:
                angulo_linea=(pi*(azimut+60))/180
            
        azimut=(pi*azimut)/180
        
   

        print("distancia palmas:" + str(distancia) + " distancialineas:" + str(distancia2) +"azimut:" + str(180*azimut/pi) + " angulo linea:" + str(180*angulo_linea/pi))
        i=0

        while  convexhull.contains(PuntoNuevo):
            if palma==1:
                PalmaUno=PuntoNuevo
                #print ("Se guarda palma 1 de linea " + str(linea))
            #se inserta la palma
            if geom.contains(PuntoNuevo):
                i=i+1
                
                featPalma.setGeometry(QgsGeometry.fromPointXY(PuntoNuevo))
                featPalma.setAttributes([i,PuntoNuevo.x(),PuntoNuevo.y(),lote + "-" + str(linea) +"-" + str(palma),lote,linea,palma])
                tmp_Palmas.dataProvider().addFeatures([featPalma]) 
                palma=palma+1
            py=PuntoNuevo.y()+(sin(azimut)*distancia) #calculo de la nueva coordenada de la palma 
            px=PuntoNuevo.x()+(cos(azimut)*distancia)
            PuntoNuevo=QgsPointXY(px,py)
            
            
            if convexhull.contains(PuntoNuevo):
                continue
            else: # se calcula la palma de lanueva linea
                
                if isosceles.isChecked():
                    #py=PalmaUno.y()+((distancia)/tan(angulo_linea))
                    #px=PalmaUno.x()+(tan(angulo_linea)*(distancia2/2)) #calculo de la nueva coordenada de la palma 
                    
                    py=PalmaUno.y()+(sin(angulo_linea)*hipotenusa) #calculo de la nueva coordenada de la palma 
                    px=PalmaUno.x()+(cos(angulo_linea)*hipotenusa)
                    print(str(px) + "," + str(py))    
                else:
                    py=PalmaUno.y()+(sin(angulo_linea)*distancia) #calculo de la nueva coordenada de la palma 
                    px=PalmaUno.x()+(cos(angulo_linea)*distancia)
                    
                PuntoNuevo=QgsPointXY(px,py)
                palma=1
                linea=linea+1

                #Se realiza revision hacia atras para fijar limite
                if geom.contains(PuntoNuevo):
                    while geom.contains(PuntoNuevo):
                        print ("Iteracion 1")
                        
                        py=py-(sin(azimut)*distancia)
                        px=px-(cos(azimut)*distancia)
                        
                        PuntoTemp=QgsPointXY(px,py)
                        if geom.contains(PuntoTemp):
                            PuntoNuevo=QgsPointXY(px,py)
                        else:
                            break
                else:
                    while  rec_lote.contains(PuntoNuevo):
                        print ("iteracion 2")

                        py=PuntoNuevo.y()+(sin(azimut)*distancia)
                        px=PuntoNuevo.x()+(cos(azimut)*distancia)
                        PuntoNuevo=QgsPointXY(px,py)
                        if geom.contains(PuntoNuevo):
                            break
                    
        print ("Acaba el proceso con " + str(i) + " palmas" + ", angulo linea" )
        tmp_Palmas.commitChanges()
       

        iface.mapCanvas().refresh()
    
    
    def multiplot(self):
    
        # Combobox need a layer selected
        if self.dlg.cbLayer_2.currentIndex() <0:
            QMessageBox.information(self.iface.mainWindow(),'Atención', 'Seleccione una capa para continuar')
            return None
        
        
            
        
        #Layer selected
        registry = QgsProject.instance()
        layer=registry.mapLayersByName( self.dlg.cbLayer_2.currentText() )[0]
        
        # Plants layer type point
        tmp_Palmas=QgsVectorLayer("Point?crs=epsg:3116&field=id:integer""&field=x:double""&field=y:double""&field=codigo:string""&field=lote:string""&field=linea:integer""&field=planta:integer&index=yes","plantas","memory")
                
        if self.dlg.leSave_2.text() =="Temporal" or self.dlg.leSave_2.text() =="" :
            QgsProject.instance().addMapLayer(tmp_Palmas)
        else:
            QgsVectorFileWriter.writeAsVectorFormat(tmp_Palmas, self.dlg.leSave_2.text(), "UTF-8", tmp_Palmas.crs(), "ESRI Shapefile")
            tmp_Palmas=QgsVectorLayer(self.dlg.leSave.text(),"Plantas")
            QgsProject.instance().addMapLayer(tmp_Palmas)
          

        
        
        #-------------------------------------------Begin process for each polygon from layer
        
        
        #Asign fields to variables
        x_field=self.dlg.cb_x.currentText()
        y_field=self.dlg.cb_y.currentText()
        direction_field=self.dlg.cb_direction_2.currentText()
        azimuth_field=self.dlg.cb_azimuth.currentText()
        plant_distance=self.dlg.cb_plantdist.currentText()
        line_distance=self.dlg.cb_linedist.currentText()
        fixtype=self.dlg.cb_fix_2.currentText()
        plotname=self.dlg.cb_plot.currentText()
        
        for f in layer.getFeatures():
            
            #Select current polygon from layer
            geom = f.geometry()
            
            #QMessageBox.information(self.iface.mainWindow(),'Atención', f[plotname] + ' x:' + str(f[x_field]) + ' y:' + str(f[y_field]) )
            #QMessageBox.information(self.iface.mainWindow(),'Atención', "Area: " + str(geom.area()))
        
            layer_crs =layer.crs()
        
            #Make point of first plant
            punto=QgsPointXY(f[x_field],f[y_field])
       
        
            palma=1
            linea=1
            azimut=f[azimuth_field]
            direccion=f[direction_field]  # 1 si es derecha, 2 si es izquierda
            distancia=f[plant_distance]
            distancia2=f[line_distance]
            fix_type=f[fixtype]
            hipotenusa=sqrt(((distancia/2)*(distancia/2))+(distancia2*distancia2))
            lote=f[plotname]
            print("hipo: " +str(hipotenusa))
        
            #Point into the polygon
            if not geom.contains(punto):
                QMessageBox.information(self.iface.mainWindow(),'Atención', 'La palma 1 no se encuentra contenida en el lote')
                return None

            #Layer is vector
            if not layer.isValid():
                QMessageBox.information(self.iface.mainWindow(),'Atención', 'La capa seleccionada no es tipo vector')
                return None

            # Se valida si la capa es poligono wkbType==3
            #if layer.wkbType()!=QgsWkbTypes.PolygonGeometry:
            #    QMessageBox.information(self.iface.mainWindow(),'Atención', 'La capa seleccionada no es de tipo polígono, seleccione una capa tipo polígono')
            #    return None
            #else:
            #    if layer_crs.mapUnits()!=0:
            #        QMessageBox.information(self.iface.mainWindow(),'Atención', 'La capa debe tener coordenadas planas')
            #        return None
            
            #Line distance is greater than 0
            if distancia<=0:
                QMessageBox.information(self.iface.mainWindow(),'Atención', 'La distancia entre las líneas debe ser mayor a 0')
                return None

            # Enveloped polygon
            convexhull=geom.convexHull()
            polBuffer=geom.buffer(distancia*20,1) # Se aumenta a 10 la distancia para garantizar que se cubra la parte externa del poligono en el caso de poligonos irregulares

            # Square enveloped
            rec_lote = geom.boundingBox()

            # RSC on layer
            CRS = layer.crs().postgisSrid()

            # CrTemporal layer for enveloped polygon
            URI = "Polygon?crs=epsg:"+str(CRS)+"&field=id:integer""&index=yes"
            tmp_AreaGeneral=QgsVectorLayer(URI,"convexhull","memory")
            #QgsMapLayerRegistry.instance().addMapLayer(tmp_AreaGeneral)

            tmp_AreaGeneral.startEditing()
            feat2 = QgsFeature()
            feat2.setGeometry(convexhull)
            feat2.setAttributes([1])
            tmp_AreaGeneral.addFeature(feat2)
            tmp_AreaGeneral.commitChanges()
            iface.mapCanvas().refresh()



            # Created Plants

            tmp_Palmas.startEditing()
            featPalma=QgsFeature()

            PuntoNuevo=punto
            px=PuntoNuevo.x()
            py=PuntoNuevo.y()


            if azimut<=90:
                azimut=90-azimut
            else:
                azimut=450-azimut
            
     
            
            if direccion==1:#If lines direction is right
                if fix_type==1:#Isosceles
                    angulo_linea=(pi*azimut)/180 - atan((distancia2)/(distancia/2))
                    
                if fix_type==2: #Tresbolillo
                    angulo_linea=(pi*(azimut-60))/180
                    
                if fix_type==3: # Grilla
                    angulo_linea=(pi*(azimut-90))/180
                    
            else:#If lines direction is left
                if fix_type==1:#Isosceles
                    angulo_linea=(pi*azimut)/180 + atan((distancia2)/(distancia/2))
                    
                if fix_type==2: #Tresbolillo
                    angulo_linea=(pi*(azimut+60))/180
                    
                if fix_type==3: # Grilla
                    angulo_linea=(pi*(azimut+90))/180
                    
                

            
            azimut=(pi*azimut)/180

            #mensaje=("lote"+ f[plotname]+"distancia palmas:" + str(distancia) + " distancialineas:" + str(distancia2) +"azimut:" + str(180*azimut/pi) + " angulo linea:" + str(180*angulo_linea/pi))
            #QMessageBox.information(self.iface.mainWindow(),'Atención',mensaje)
            
            
            i=0

            while  convexhull.contains(PuntoNuevo):
                if palma==1:
                    PalmaUno=PuntoNuevo
                    #print ("Se guarda palma 1 de linea " + str(linea))
                #se inserta la palma
                if geom.contains(PuntoNuevo):
                    i=i+1
                    
                    featPalma.setGeometry(QgsGeometry.fromPointXY(PuntoNuevo))
                    featPalma.setAttributes([i,PuntoNuevo.x(),PuntoNuevo.y(),lote + "-" + str(linea) +"-" + str(palma),lote,linea,palma])
                    tmp_Palmas.dataProvider().addFeatures([featPalma]) 
                    palma=palma+1
                
                #Point Coords of new plant
                py=PuntoNuevo.y()+(sin(azimut)*distancia) #calculo de la nueva coordenada de la palma 
                px=PuntoNuevo.x()+(cos(azimut)*distancia)
                PuntoNuevo=QgsPointXY(px,py)
                
                if fixtype==3: # Grilla
                    QMessageBox.information(self.iface.mainWindow(),'Atención','Grilla aqui' + str(px)+' '+str(py))
                    
                if convexhull.contains(PuntoNuevo): #If new point is in the polygon, continue in the same line
                    continue
                else: # If the new point out of the poilygon, move the point to new line
                    
                    #Coords of new plant in the next line, considering fix type
                    if fix_type==1:#Isosceles
                        #py=PalmaUno.y()+((distancia)/tan(angulo_linea))
                        #px=PalmaUno.x()+(tan(angulo_linea)*(distancia2/2)) #calculo de la nueva coordenada de la palma 
                        
                        py=PalmaUno.y()+(sin(angulo_linea)*hipotenusa) #calculo de la nueva coordenada de la palma 
                        px=PalmaUno.x()+(cos(angulo_linea)*hipotenusa)
                        print(str(px) + "," + str(py))    
                    if fix_type==2: #Tresbolillo
                        py=PalmaUno.y()+(sin(angulo_linea)*distancia) #calculo de la nueva coordenada de la palma 
                        px=PalmaUno.x()+(cos(angulo_linea)*distancia)
                        
                    if fix_type==3: # Grilla
                        py=PalmaUno.y()+(sin(angulo_linea)*distancia2) #calculo de la nueva coordenada de la palma 
                        px=PalmaUno.x()+(cos(angulo_linea)*distancia2)
                        QMessageBox.information(self.iface.mainWindow(),'Atención','Grilla aqui' + str(px)+' '+str(py))
                    

                    
                    PuntoNuevo=QgsPointXY(px,py)
                    palma=1
                    linea=linea+1

                    #Se realiza revision hacia atras para fijar limite
                    if geom.contains(PuntoNuevo):
                        while geom.contains(PuntoNuevo):
                            print ("Iteracion 1")
                            
                            py=py-(sin(azimut)*distancia)
                            px=px-(cos(azimut)*distancia)
                            
                            PuntoTemp=QgsPointXY(px,py)
                            if geom.contains(PuntoTemp):
                                PuntoNuevo=QgsPointXY(px,py)
                            else:
                                break
                    else:
                        while  rec_lote.contains(PuntoNuevo):
                            print ("iteracion 2")

                            py=PuntoNuevo.y()+(sin(azimut)*distancia)
                            px=PuntoNuevo.x()+(cos(azimut)*distancia)
                            PuntoNuevo=QgsPointXY(px,py)
                            if geom.contains(PuntoNuevo):
                                break
                        
            print ("Acaba el proceso con " + str(i) + " palmas" + ", angulo linea" )
        tmp_Palmas.commitChanges()
       

        iface.mapCanvas().refresh()
    
    
    
    
    
    #Funcion para calcular distancia entre líneas
    #def function(Dist)
     #   distancia=self.dlg.dblDistance.value()
      #  self.dlg.dblDistance_2.value()=sqrt(((distancia/2)*(distancia/2))+(distancia*distancia))
        
    def run(self):
        """Run method that performs all the real work"""
        
        if self.first_start == True:
            self.first_start = False
            self.dlg = PlantingPatternDialog()
            self.dlg.btSave.clicked.connect(self.select_output_file)
            self.dlg.bt_funcion.clicked.connect(self.funcion)
            self.dlg.bt_run_2.clicked.connect(self.multiplot)
            #Update field list in parameters 
            self.dlg.cbLayer_2.activated.connect( self.onLayerChange)
            #self.dlg.dblDistance.command
            #self.dlg.leSave.clear()
        
        #QMessageBox.information(self.iface.mainWindow(),"Algo","Otro")
        #Parametros de GUI
        #Load layer list
        layers = iface.mapCanvas().layers()
        
        #Clear layer comoboxes
        self.dlg.cbLayer.clear()
        self.dlg.cbLayer_2.clear()
        
        #Add layer list to combobox
        for layer in layers:
            self.dlg.cbLayer.addItem(layer.name(),layer)
            self.dlg.cbLayer_2.addItem(layer.name(),layer)
        
        #Clear direction combobox
        self.dlg.cbDirection.clear()

        
        #Add items to combobox direction
        self.dlg.cbDirection.addItems(["Izquierda","Derecha"])
    
        
        

        
        
        
		# show the dialog
        self.dlg.show()
        
        # Run the dialog event loop
        result = self.dlg.exec_()
        
        
        # See if OK was pressed
        if result:
            pass

